// filefindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "filefind.h"
#include "filefindDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CfilefindDlg dialog




CfilefindDlg::CfilefindDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CfilefindDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CfilefindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_FileListBox);
	DDX_Control(pDX, IDC_LIST2, m_FileHashNumberList);
}

BEGIN_MESSAGE_MAP(CfilefindDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CfilefindDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_FIND, &CfilefindDlg::OnBnClickedFind)
END_MESSAGE_MAP()


// CfilefindDlg message handlers

BOOL CfilefindDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CfilefindDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CfilefindDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CfilefindDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

unsigned long rGetHashCode(const char* pString)
{
	unsigned long hash = 5381;
	int len = strlen(pString);
	for(int i = 0; i < len; ++i)
	{
		hash = ((hash << 5) + hash) + (unsigned long)pString[i]; // hash * 33 + ch
	}  
	return hash;
}

void CfilefindDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE);
	if(dlg.DoModal() != IDOK) return;

	m_FileListBox.ResetContent();
	m_FileHashNumberList.ResetContent();
	m_Container.clear();

	CFileFind ff;
	BOOL b = ff.FindFile("*.*");
	while(b)
	{
		b = ff.FindNextFile();

		if(!ff.IsDirectory())
		{
			CString filename = ff.GetFileName();
			m_FileListBox.AddString(filename);		

			unsigned long hashcode = rGetHashCode((LPCTSTR)filename);
			CString number;
			number.Format("%u", hashcode);
			m_FileHashNumberList.AddString(number);

			m_Container[ hashcode ] = (LPCTSTR)filename;			
		}
	}

	//OnOK();
}

#include "InputDialog.h"

void CfilefindDlg::OnBnClickedFind()
{
	// TODO: Add your control notification handler code here
	if( m_Container.size() < 1) return;

	CInputDialog dlg;
	if(dlg.DoModal() == IDCANCEL) return;

	unsigned long hashcode = rGetHashCode((LPCTSTR)dlg.m_InputData);

	std::map< unsigned long, std::string >::iterator it;
	it = m_Container.find( hashcode );
	if(it != m_Container.end())
	{
		AfxMessageBox("ãҽϴ.");
	}
	else
	{
		AfxMessageBox(" ȭϸԴϴ");
	}
}
